class ScrollPanel < Peta::Leaf
  load_manifest
  belongs_to :author
  belongs_to :panel
  belongs_to :scroll
  
  validates :scroll_id, :presence => true, :numericality => true, :existence => {:both => false}
  validates :panel_id, :presence => true, :numericality => true, :existence => {:both => false}
  validates :t, :presence => true, :numericality => {:greater_than_or_equal_to => 0}
  
  def supply_default
    self.scroll_id = nil
    self.panel_id = nil
    self.t = nil
  end
  
  def overwrite operators
  end
  
  def self.public_list_where list
    'scrolls.visible > 0'
  end
  
  def self.by_author_list_includes
    {
      :scroll => {
        :author => {}
      }
    }
  end
  
  def self.show_opt
    {:include => {
      :scroll => {
        :author => {}
      }, 
    }}
  end
  
  def self.licensed_pictures scroll_panels
    Panel.licensed_pictures scroll_panels.select {|sp| sp.panel }.map {|sp| sp.panel }
  end
  
  def allow? operators
    return nil if self.scroll_id == nil or self.panel_id == nil
    self.scroll.own?(operators) and self.panel.usable?(operators)
  end
  
end
