module Editor
  module EditorModule
    module DockModule
      class ElementBoard < Board
        attr_accessor :element
        
        def initialize parent, index, name, element
          super parent, index, name
          @element = element
        end
        
        def template_dir
          @parent.template_dir + 'board/'
        end
        
        def template_file_name
          'element'
        end
        
      end
      
      module TabModule
        class ElementBoardLabel < BoardLabel
          def template_file_name
            'board_label'
          end
          
          def face_template_name
            self.element.path_name + '/element_face'
          end
          
        end
        
        class ElementBoardBody < BoardBody
          attr_accessor :bucket
          
          def initialize parent
            super
            @form = Locmare::Bucket.new self.element.item_name, 'default', self.element, self.mounted, false, @operators
            @bucket = FormBucket.new self, @form
          end
          
          def template_name
            @bucket.template_name
          end
          
          def template_options
            @bucket.template_options
          end
          
          def mounted
            true
          end
          
          def element
            @parent.element
          end
          
        end
        
      end
    end
  end
end
