module Locmare
  module ProfilerModule
    module ColumnModule
      class Source < Base
        
        def select_item_name
          self.model_attribute_source_manifest.select_item_name
        end
        
        def model_manifest
          ::Manifest.manifest.models[@profiler.item_name]
        end
        
        def model_attribute_manifest
          self.model_manifest.attributes[@column_name]
        end
        
        def model_attribute_source_manifest
          self.model_attribute_manifest.source
        end
        
        def translate?
          self.model_attribute_source_manifest.translate?
        end
        
        def template_file_name
          "source"
        end
        
        def note_template_dir 
          @profiler.template_dir + "column_note/"
        end
        
        def note_template_file_name
          'default'
        end
        
        def note_template_name
          self.note_template_dir + self.note_template_file_name
        end
        
      end
    end
  end
end
